org.apache.felix.framework

## Class HookRegistry

- java.lang.Object
- - org.apache.felix.framework.HookRegistry

    public class HookRegistry
    extends Object

This registry holds all services implementing one of the hook services

### Constructor Summary

Constructors
Constructor and Description
`HookRegistry()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addHooks(String[] classNames, Object svcObj, ServiceReference<?> ref)` Check and add the service to the set of hooks
`void` `blackListHook(ServiceReference<?> sr)`
`<S> Set<ServiceReference<S>>` `getHooks(Class<S> hookClass)` Return the sorted set of hooks
`boolean` `isHookBlackListed(ServiceReference<?> sr)`
`void` `removeHooks(ServiceReference<?> ref)` Remove the service hooks
`void` `updateHooks(ServiceReference<?> ref)` Update the service ranking for a hook

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### HookRegistry

    public HookRegistry()

### Method Detail

#### addHooks

    public void addHooks(String[] classNames,
                         Object svcObj,
                         ServiceReference<?> ref)

Check and add the service to the set of hooks

Parameters:
  `classNames` - The service names
  `svcObj` - The service object
  `ref` - The service reference

#### updateHooks

    public void updateHooks(ServiceReference<?> ref)

Update the service ranking for a hook

Parameters:
  `ref` - The service reference

#### removeHooks

    public void removeHooks(ServiceReference<?> ref)

Remove the service hooks

Parameters:
  `ref` - The service reference

#### getHooks

    public <S> Set<ServiceReference<S>> getHooks(Class<S> hookClass)

Return the sorted set of hooks

Parameters:
  `hookClass` - The hook class
Returns:
  The sorted set - the set might be empty

#### isHookBlackListed

    public boolean isHookBlackListed(ServiceReference<?> sr)

#### blackListHook

    public void blackListHook(ServiceReference<?> sr)